package stream.dashboard;

import java.awt.Color;

public abstract class Chart {

	public final static Color[] COLORS = new Color[] { new Color(50, 119, 188),
			new Color(23, 54, 85), new Color(38, 89, 138),
			new Color(79, 111, 138), new Color(160, 197, 254),
			new Color(117, 160, 209), Color.RED, Color.GREEN, Color.CYAN,
			Color.BLUE };

	String aspect;
	ColorMapping colorMapping = new DefaultColorMapping();

	public Chart(String aspect) {
		this.aspect = aspect;
	}

	public Color getColor(int i) {
		return COLORS[i % COLORS.length];
	}

	public Color getColor(String str) {

		if (str.indexOf(".") >= 0) {
			String[] tok = str.split("\\.");
			return colorMapping.map(tok[0], tok[1]);
		}

		return colorMapping.map(aspect, str);
	}
}