/**
 * 
 */
package stream.dashboard;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.JScrollPane;

import stream.Data;
import stream.ProcessContext;

/**
 * @author chris
 * 
 */
public class Matrix extends Widget {

	/** The unique class ID */
	private static final long serialVersionUID = 2825780723261364090L;

	MatrixChart matrix = new MatrixChart();
	JScrollPane scroller;
	String from = "user";
	String to = "host";

	Thread updateUi;
	final List<String[]> data = new ArrayList<String[]>();

	/**
	 * @see stream.dashboard.Widget#init(stream.ProcessContext)
	 */
	@Override
	public void init(ProcessContext ctx) throws Exception {
		super.init(ctx);
		scroller = new JScrollPane(matrix);
		scroller.setBorder(null);
		this.content.add(scroller);
		if (this.titleString == null) {
			this.setTitle("Matrix:  " + from + " x " + to);
		}

		updateUi = new Thread() {
			public void run() {
				while (true) {
					synchronized (data) {

						if (data.isEmpty()) {
							matrix.tick();
						}

						Iterator<String[]> it = data.iterator();
						while (it.hasNext()) {
							String[] d = it.next();
							matrix.add(d[0], d[1]);
							it.remove();
						}
						scroller.validate();
					}
					try {
						Thread.sleep(1000);
					} catch (Exception e) {
					}
				}
			}
		};
		updateUi.setDaemon(true);
		updateUi.start();
	}

	/**
	 * @see stream.dashboard.Widget#process(stream.Data)
	 */
	@Override
	public Data process(Data input) {

		if (input == null)
			return input;

		Serializable f = input.get(from);
		Serializable t = input.get(to);

		if (f != null && t != null) {

			synchronized (data) {
				data.add(new String[] { f.toString(), t.toString() });
			}
			// matrix.add(f.toString(), t.toString());
			// scroller.validate();
		}

		return input;
	}

	/**
	 * @return the from
	 */
	public String getFrom() {
		return from;
	}

	/**
	 * @param from
	 *            the from to set
	 */
	public void setFrom(String from) {
		this.from = from;
	}

	/**
	 * @return the to
	 */
	public String getTo() {
		return to;
	}

	/**
	 * @param to
	 *            the to to set
	 */
	public void setTo(String to) {
		this.to = to;
	}
}